/*
 * wiz_cmd_keeper.c
 *
 * This object holds the commands reserved for administrators.
 *
 */
#pragma save_binary

inherit "/cmd/std/command_driver";

#include "/sys/stdproperties.h"
#include "/sys/filepath.h"
#include "/sys/language.h"
#include "/secure/std.h"
#include "/sys/macros.h"

#define CHECK_SO_KEEPER	if (WIZ_CHECK < WIZ_KEEPER) return 0; \
			if (this_interactive() != this_player()) return 0

/* **************************************************************************
 * Return a list of which souls are to be loaded.
 * The souls are listed in order of command search.
 */
get_soul_list()
{
    return ({ WIZ_CMD_KEEPER,
	      WIZ_CMD_ARCH,
	      WIZ_CMD_LORD,
	      WIZ_CMD_NORMAL,
	      WIZ_CMD_PILGRIM,
	      WIZ_CMD_APPRENTICE });
}

/* **************************************************************************
 * Return a proper name of the soul in order to get a nice printout.
 */
get_soul_id()
{
    return WIZ_LEV_NAME(WIZLEV_KEEPER);
}

/* **************************************************************************
 * The list of verbs and functions. Please add new in alfabetical order.
 */
mapping
query_cmdlist()
{
    return ([]);
}
    
/* **************************************************************************
 * Here follows the actual functions. Please add new functions in the 
 * same order as in the function name list.
 * **************************************************************************/
