/*
 * wiz_cmd_mage.c
 *
 * This object holds the mage wizards commands. (WIZ_MAGE)
 *
 */
#pragma save_binary

inherit "/cmd/std/command_driver";

#include "/secure/std.h"
#include <macros.h>

#define CHECK_SO_WIZ 	if (WIZ_CHECK < WIZ_MAGE) return 0; \
			if (this_interactive() != this_player()) return 0

/* **************************************************************************
 * Return a list of which souls are to be loaded.
 * The souls are listed in order of command search.
 */
string *
get_soul_list()
{
    return ({ WIZ_CMD_MAGE,
	      WIZ_CMD_NORMAL,
	      WIZ_CMD_PILGRIM,
	      WIZ_CMD_APPRENTICE });
}

/* **************************************************************************
 * Return a proper name of the soul in order to get a nice printout.
 */
string
get_soul_id()
{
    return WIZ_LEV_NAME(WIZLEV_MAGE);
}

/* **************************************************************************
 * The list of verbs and functions. Please add new in alfabetical order.
 */
mapping
query_cmdlist()
{
    return ([ "snort":"snort" ]);
}

/* **************************************************************************
 * Here follows the actual functions. Please add new functions in the 
 * same order as in the function name list.
 * **************************************************************************/

/* **************************************************************************
 * snort - snort at peasants
 */
int
snort(string name)
{
    object snortee;

    CHECK_SO_WIZ;

    if (WIZ_CHECK != WIZ_MAGE)
    {
	notify_fail("No one can snort like a Mage. You would only look ridiculous if you tried.\n");
	return 0;
    }

    if (!strlen(name))
    {
	notify_fail("Snort at who?\n");
	return 0;
    }

    snortee = present(name, environment(this_player()));
    if (!snortee)
    {
	notify_fail("Snort at who?\n");
	return 0;
    }
    
    if (WIZ_TYPE(snortee->query_wiz_level()) < WIZ_MAGE)
    {
	say(QCTNAME(this_player()) + " snorts disdainfully at " + QTNAME(snortee) + ".\n", ({ this_player(), snortee }));
	tell_object(snortee, capitalize((string)this_player()->query_real_name()) + " snorts disdainfully at you.\n");
	write("You snort disdainfully at " + capitalize(name) + ".\n");
    }
    else
    {
	write(capitalize(name) + " looks quite respectable and doesn't deserve that kind of treatment.\n");
    }

    return 1;
}
