/*
This is a special player object that is used when a restore_object
is performed in the finger_player() function of the master object.
It saves a lot of time compared to loading a normal player object.
*/
#include "/config/sys/local.h"

inherit MAIL_INFO_OBJ;
inherit SPECIAL_INFO_OBJ;

#include <std.h>
#include <const.h>
#include <living_desc.h>
#include <state_desc.h>
#include <language.h>
#include <ss_types.h>

string race_name, title, name, mailaddr, player_file, login_from, al_title;
string password, *adj_desc, *seconds;

int exp_points, exp_combat, age_heart, gender, login_time, is_ghost, wiz_level;
int *learn_pref,*acc_exp;

int stats_set=0;
int *stats;

mapping m_sanctioned = ([]);

#define STAT if (!stats_set) acc_exp_to_stats()
static void acc_exp_to_stats();

void
create()
{ 
    seteuid(0);
}

void
finger_info()
{
    finger_mail();
    finger_special();
}

nomask public int
load_player(string pl_name)
{
    int ret;
   
    if (!pl_name)
	return 0;
    if (member_array(" ", explode(pl_name, "")) >= 0)
        return 0;

    seteuid(getuid(this_object()));
    ret = restore_object(PLAYER_FILE(pl_name));
    seteuid(0);
    return ret;
}
nomask void
master_set_name(string n)
{
    if (previous_object() != find_object(SECURITY))
	return;

    name = n;
}

public nomask void
open_player()
{
    if (previous_object() == find_object(SECURITY))
	seteuid(0);
}

public int
notmet_me(object obj)
{
    if (obj && query_ip_number(obj))
	return !obj->query_met(this_object());
    return !this_player()->query_met(this_object());
}
string query_race_name() { return race_name; }
string query_title() { return title; }
string query_real_name() { return name; }
string query_name() { return capitalize(name); }
string query_met_name() { return capitalize(name); }
mixed
query_adj(int param)
{
    if (param)
	return adj_desc;
    else
	return adj_desc[0];
}
public string
query_nonmet_name()
{
    string *adj, str;

    if (sizeof((adj = query_adj(1))) > 0)
        str = implode(adj, " ") + " " +
            race_name +
            (wiz_level ? (" " + LD_WIZARD) : "");
    else
        str = race_name +
            (wiz_level ? (" " + LD_WIZARD) : "");

    if (is_ghost & 1)
        str += " " + LD_GHOST;

    return str;
}
string
query_the_name(object pobj)
{
    if (!objectp(pobj))
	pobj = previous_object(-1);

    if (notmet_me(pobj))
	return LD_THE + " " + query_nonmet_name();
    else
	return query_met_name();
}
string query_The_name(object pobj) { return capitalize(query_the_name(pobj)); }
string query_mailaddr() { return mailaddr; }
string query_player_file() { return player_file; }
string query_login_from() { return login_from; }
int    query_login_time() { return login_time; }
string query_pronoun() {return LD_PRONOUN_MAP[gender];}
string query_gender_string() { return LD_GENDER_MAP[gender]; }
int    query_age() { return age_heart; }
string query_password() { return password; }
int    query_exp() { return exp_points; }
int    query_exp_combat() { return exp_combat; }
mapping query_sanctioned() { return m_sanctioned; }

string
query_sanctioning(string who)
{
    return "" + m_sanctioned[who];
}

public string
query_exp_title()
{
    int a,i,s;
    string *t;

    if (wiz_level) 
        return "";

    return "nonpresent mortal";

#if 0
    /* We don't want to spend time on trivial things like this */
    a = this_object()->query_average_stat();
    if (stringp(SD_AV_TITLES))
        t = explode(SD_AV_TITLES + " "," ");
    else
        t = SD_AV_TITLES;

    s = sizeof(t);
    
    for (i = 0; i < s; i++) 
    {
        if (a < ((100 * i) / s)) 
            return t[i];
    }
    return t[s - 1];
#endif
}

string short() { return query_name();}
int query_ghost() { return is_ghost; }
int query_wiz_level() { return wiz_level; }

string 
long(mixed for_obj)
{
    return LD_PRESENT_TO(this_object());
}    

public string
query_objective()
{
    return LD_OBJECTIVE_MAP[gender];
}

public string
query_presentation()
{
    string b;
    
    b = query_exp_title(); 

    return query_name() + 
        (strlen(title) ? (" " + title + ",") : "") +
        (strlen(b) ? (" " + b + ",") : "") + " " +
        query_gender_string() + " " + 
        race_name + 
        (strlen(al_title) ? (" (" + al_title + ")") : "");
}

public mixed
query_learn_pref(int stat)
{
    if (stat < 0) return learn_pref;

    if (stat < 0 || stat >= SS_NO_STATS)
        return -1;

    return learn_pref[stat];
}

public int
query_acc_exp(int stat)
{
    if (stat < 0 || stat >= SS_NO_STATS)
        return -1;
    return acc_exp[stat];
}

int
set_base_stat(int stat, int val)
{
    if (stat < 0 || stat >= SS_NO_STATS || val < 1 )
        return 0;
    stats[stat] = val;
    return val;
}
  
nomask int
exp_to_stat(int exp)
{
    int lo, hi, base, delta;
    lo = 0;
    hi = 1000;
    base = 500;
    delta = 500;

    while (delta > 0)
    {
        if (exp >= base * base * base)
            lo = base;
        else
            hi = base;
        delta = (hi - lo) / 2;
        base = lo + delta;
    }
    return base;
}

public int
query_base_stat(int stat)
{
    STAT;
    if (stat < 0 || stat >= SS_NO_STATS)
        return -1;
    return stats[stat];
}

static void
acc_exp_to_stats()
{
    int il, tmp;

    stats = allocate(SS_NO_STATS);
    stats_set = 1;

    for (il = SS_STR; il < SS_NO_STATS; il++)
    {
        if (query_base_stat(il) >= 0)
        {
            tmp = exp_to_stat(query_acc_exp(il));
            set_base_stat(il, tmp);
        }
    }
}

int
query_stat(int stat)
{
    int tmp;

    if (stat < 0 || stat >= SS_NO_STATS)
        return -1;

    tmp = query_base_stat(stat);

    return (tmp > 0 ? tmp : 1);
}

string
show_age()
{
    int i, j;
    string str;

    str = "";
    i = query_age();
    if (j = i / 43200)
    {
        if (j > 1)
            str += " " + j + " days";
        else
            str += " 1 day";
        i = i - j * 43200;
    }
    if (j = i / 1800)
    {
        if (j > 1)
            str += " " + j + " hours";
        else
            str += " 1 hour";
        i = i  - j * 1800;
    }
    if (j = i / 30)
    {
        if (j > 1)
            str += " " + j + " minutes";
        else
            str += " 1 minute";
        i = i - (i / 30) * 30;
    }
    if ((j = i * 2) > 1)
        str += " " + i * 2 + " seconds";
    else if (j == 1)
        str += " 1 second";

    return str;
}

string
stat_living()
{
    string str;
    object to;

    to = this_object();
    str = sprintf(
                  "Name: %15s(%-15s   Race: %-10s    Gender: %-10s\n" +
                  "------------------------------------------------------" +
                  "----------------------\n" +
                  "Exp: %-7d    Expquest: %-7d\n" +
                  "Stats:     %@7s\n"  +
                  "    Val:   %@7d\n" +
                  "    Acc:   %@7d\n" +
                  "  Learn:   %@7d\n" 
                  ,
                  to->query_name(), query_real_name()+")",
                  to->query_race_name(),
                  to->query_gender_string(),
                  to->query_exp(), to->query_exp() - to->query_exp_combat(),
                  SS_STAT_DESC,
                  ({ to->query_stat(SS_STR), to->query_stat(SS_DEX),
                     to->query_stat(SS_CON), to->query_stat(SS_INT),
                     to->query_stat(SS_WIS), to->query_stat(SS_DIS),
                     to->query_stat(SS_RACE), to->query_stat(SS_GUILD),
                     to->query_stat(SS_OTHER) }),
                  ({ to->query_acc_exp(SS_STR), to->query_acc_exp(SS_DEX),
                     to->query_acc_exp(SS_CON), to->query_acc_exp(SS_INT),
                     to->query_acc_exp(SS_WIS), to->query_acc_exp(SS_DIS),
                     to->query_acc_exp(SS_RACE), to->query_acc_exp(SS_GUILD),
                     to->query_acc_exp(SS_OTHER) }),
                  to->query_learn_pref(-1)
                  );
    return str;
}

void 
remove_object()
{
    destruct();
}

public string *
query_seconds()
{
    if (!sizeof(seconds))
	seconds = ({});
    
    return seconds;
}
