/*
 * /secure/master/notify.c
 *
 * The code handling notifying wizards who's loggin on or off
 * Thanks to Falke from Angalon
 */

/*
 * Function name: notify
 * Description:	  Notify wizards who wants to hear when someone leaves or
 *		  enters the game
 * Arguments:	  ob    - The player object entering or leaving
 *		  name  - Name of ob
 *		  in    - 1 entering, 0 leaving
 *		  ld    - 1 is linkdead, 0 is not
 */
void
notify(object ob, string name, int in, int ld)
{
    string message, ip, link;
    object *players;
    int notify_lvl, i, notify, ob_lvl;
    mixed str;

    players = users();
    notify_lvl = 0;

    if (!name)
	return;
    message = "[" + capitalize(name) + " ";
    if (str = query_ip_name(ob))
    	ip = "(" + query_ip_name(ob) + ") ";
    else
	ip = "";

    if (ld)
    {
	if (in)
	    link = "revives from link-death.";
	else
	    link = "link-died.";
    }
    else
    {
	if (in)
	    link = "logged in.";
 	else
	    link = "logged out.";
    }

    ob_lvl = ob->query_notify();

    for (i = 0; i < sizeof(players); i++)
    {
	if (!players[i] || !players[i]->query_wiz_level() ||
		name == players[i]->query_real_name())
	    continue;

	notify = 0;
	notify_lvl = players[i]->query_notify();

	if (notify_lvl < 1)
	    continue;
	if (notify_lvl & 1)
	    notify = 1;
	else if ((notify_lvl & 2) && query_wiz_level(name))
	    notify = 1;
	else if ((notify_lvl & 4) && (query_wiz_level(name) > WIZLEV_MAGE))
	    notify = 1;
	else if ((notify_lvl & 8) &&
		(query_wiz_level(name) > WIZLEV_RETIRED) &&
		(query_wiz_dom(name) == players[i]->query_domain()))
	    notify = 1;

	/* Reason to use catch_msg() is to let busy F block the notifier.
	 * Maybe the wizard is only writing a letter and wants silence for
	 * the moment ?
	 */
	if (notify && (!ld || !(notify_lvl & 32)) &&
		(!(ob_lvl & 64) ||
		WIZ_TYPE(ob->query_wiz_level()) <
			WIZ_TYPE(players[i]->query_wiz_level()) ||
		WIZ_TYPE(players[i]->query_wiz_level()) >= WIZ_ARCH))
	    players[i]->catch_msg(message + (notify_lvl & 16 ? ip : "") +
		link + "]" + "\n");
    }
}

