
inherit "/std/object";

#include <filepath.h>
#include <stdproperties.h>

string new_head, new_text;

void
create_object()
{
    set_name("board_updater");
    set_name("board updater");
    set_long("An object for updating savefile format of notes to the new model.\n" +
	     "Just type 'make <board savefile path>'\n" +
	     "If for example you want to update the board with the savefile\n" +
	     "'/d/Wiz/tintin/my_board.o', you type 'make /d/Wiz/tintin/my_board'.\n");

    add_prop(OBJ_I_WEIGHT, 0); 
    add_prop(OBJ_I_VOLUME, 0);
    add_prop(OBJ_I_VALUE, 0);
    add_prop(OBJ_I_NO_DROP, 1);

    seteuid(getuid(this_object()));
}

void
init()
{
    add_action("make", "make");
    write("Usage: 'make <board savefile path>'\n");
}

int
make(string str)
{
    
    int i, max, btime;
    string *headers, *messages, board_name, file_name;
    
    board_name = FTPATH(this_interactive()->query_path(), str);
    
    if (!restore_object(board_name))
    {
	write("Unable to find savefile.\n");
	return 1;
    }
    
    if (!mkdir(board_name))
    {
	write("Unable to make directory for board. (Directory may already exist.)\n");
	return 1;
    }
    
    headers = explode(new_head, "\n**\n");
    
    messages = explode(new_text, "\n**\n");

    max = (sizeof(messages) > sizeof(headers))
	   ? sizeof(headers)
	   : sizeof(messages);
    
    btime = time();
    
    for (i = 0; i < max; i++)
    {
	file_name = board_name + "/b" + (btime + i);
	write_file(file_name, headers[i] + "\n" + messages[i] + "\n");
	write("Making file " + file_name + " from note number " +
	      (i + 1) + ".\n");
    }
    
    write("Done making note files. Please remove the old savefile.\n");
    return 1;
}

