inherit "/std/object";

#include <macros.h>

string header, text = "";
int line = 1;
object board;

void
new_msg(string head_text, int show_lvl, int anonymous)
{
    string lvl_text, name;
    
    board = previous_object();
    lvl_text = "";
    if(show_lvl)
	lvl_text = ", " + this_player() -> query_wiz_level();
    if (anonymous)
	name = (string) this_player()->query_name();
    else
	name = capitalize((string) this_player()->query_real_name());
    
    header = head_text + " (" + name + ", " + extract(ctime(time()), 4, 9) +
	lvl_text + ")";
    write("Enter message text. End with '**', list with '~l', abort with '~q'.\n");
    write(line + ">>");
    input_to("get_msg");
}

void
get_msg(string str)
{
    if (str == "~q")
    {
	say(QCTNAME(this_player()) + " aborts writing a note.\n");
	write("Note aborted.\n");
	remove_object();
	return;
    }
    
    if (str == "~l")
    {
	write(text + "\n" + line + ">>");
	input_to("get_msg");
	return;
    }
    
    if (str == "**")
    {
	if (line == 1)
	{
	    write("No text entered. Message discarded.\n");
	    say(QCTNAME(this_player()) + " quits writing.\n");
	    remove_object();
	    return;
	}
	say(QCTNAME(this_player()) + " has completed a note : " +
	    header + "\n");
	write("Ok.\n");
	board->insert_message(header, text);
	remove_object();
	return;
    }
    text = text + str + "\n";
    line++;
    write(line + ">>");
    input_to("get_msg");
}
