/* 
 * key.c
 *
 * This is the standard key object.
 *
 * User function in this object:
 * -----------------------------
 *
 * Arguments:	        s = string, i = integer, o = object, m = mixed
 *			*x = list of given type.
 *			** mandatory function. 
 *			-* special circumstances apply
 *
 * All set functions has a corresponding query function defined.
 *
 *
 * create_key()		- The function that initates the object. You should
 *			  have calls to the following functions here.
 *
 * set_key(m)		- Call this function with the key for a lock to
 *			  use.
 */
#pragma save_binary

inherit "/std/object";
#include "/sys/stdproperties.h"

mixed key;

/*
 * Function name: create_key
 * Description:   Sets default names and id
 */
void
create_key() {}

/*
 * Function name: create_object
 * Description:   Initialize object.
 */
nomask void
create_object()
{
    set_name("key");
    set_pname("keys");
    add_prop(OBJ_I_VOLUME,5);
    add_prop(OBJ_I_WEIGHT,30);
    add_prop(OBJ_I_VALUE,10);
    create_key();
}

nomask void
reset_object() { this_object()->reset_key(); }

/*
 * Function name: set_key
 * Description:   Sets the key for the lock to use
 *		  keyval - the key
 */
void
set_key(mixed keyval)
{
    key = keyval;
}

/*
 * Function name: query_key
 * description:   Returns the id number of the key.
 */
mixed
query_key()
{
    return key;
}

string
stat_object()
{
    string str;

    str = ::stat_object();

    str += "Key nr: " + key + "\n";

    return str;
}

