/* 
 * /std/living/wizstat.c
 *
 * Contains the code to implement the various wizardly information commands.
 */

/*
 * Description: Give status for this living.
 */
public string stat_living()
{
    string str, tmp;
    object to;
    PROFILE("stat_living");

    to = this_object();
    str = sprintf(
		  "Name: %15s(%-15s   Race: %-10s    Gender: %-10s\n" +
	          "File: %-31s   Uid:  %-10s    Euid:   %-10s\n"  +
		  "------------------------------------------------------" +
		  "----------------------\n" +
		  "Exp: %-7d    Expquest: %-7d    Hp: %4d(%4d) " +
		  " Mana: %4d(%4d)\n" +  
		  "Fatigue: %7d(%7d)   Weight: %7d(%7d)    Volume: %7d(%7d)\n" +
		  "Stats:     %@7s\n"  +
                  "    Val:   %@7d\n" +
                  "    Acc:   %@7d\n" +
	          "  Learn:   %@7d\n" +
		  "Skills are shown by the command 'skillstat'\n" +
		  "Intox: %-6d  Headache: %-3d  Stuffed: %-3d Soaked: %-3d  " +
		  "Align: %d\n" +
		  "Scar:  %-6d  Ghost:    %-3d  Invis:   %-3d Npc:    %-3d  " +
		  "Wiz: %d  Whimpy: %d\n"
		  ,
		  to->query_name(), query_real_name()+")",
		  to->query_race_name(),
		  to->query_gender_string(),
		  file_name(this_object()), getuid(this_object()),
		  geteuid(this_object()),
		  to->query_exp(), to->query_exp() - to->query_exp_combat(),
		  to->query_hp(), to->query_max_hp(),
		  to->query_mana(), to->query_max_mana(),
		  to->query_fatigue(), to->query_max_fatigue(),
		  to->query_prop(OBJ_I_WEIGHT),
		  to->query_prop(CONT_I_MAX_WEIGHT),
		  to->query_prop(OBJ_I_VOLUME),
		  to->query_prop(CONT_I_MAX_VOLUME),
		  SS_STAT_DESC,
		  ({ to->query_stat(SS_STR), to->query_stat(SS_DEX),
		     to->query_stat(SS_CON), to->query_stat(SS_INT),
		     to->query_stat(SS_WIS), to->query_stat(SS_DIS),
		     to->query_stat(SS_RACE), to->query_stat(SS_GUILD),
		     to->query_stat(SS_OTHER) }),
		  ({ to->query_acc_exp(SS_STR), to->query_acc_exp(SS_DEX),
		     to->query_acc_exp(SS_CON), to->query_acc_exp(SS_INT),
		     to->query_acc_exp(SS_WIS), to->query_acc_exp(SS_DIS),
		     to->query_acc_exp(SS_RACE), to->query_acc_exp(SS_GUILD),
		     to->query_acc_exp(SS_OTHER) }),
		  to->query_learn_pref(-1), to->query_intoxicated(),
		  to->query_headache(), to->query_stuffed(),
		  to->query_soaked(), to->query_alignment(),
		  to->query_scar(), to->query_ghost(),
		  to->query_invis(), to->query_npc(),
		  to->query_wiz_level(), to->query_whimpy()
		  );
    if (strlen(tmp = to->query_prop(OBJ_S_WIZINFO)))
	str += "Wizinfo:\n" + tmp;

    return str;
}


public string
skill_living()
{
    string str, *skills, sk;
    int *sktypes, i;
    mapping sk_desc;

    PROFILE("skill_living");
    sk_desc = SS_SKILL_DESC;

    sktypes = query_all_skill_types();
    sk = "";

    if (sizeof(sktypes))
    {
	skills = map(sktypes, "fix_skill_desc", this_object(), sk_desc);
	for(i = 0; i < sizeof(skills); i += 2)
	{
	    sk += sprintf("%35s ", skills[i]);
	    if(i + 1 < sizeof(skills))
		sk += sprintf("%35s", skills[i + 1]) + "\n";
	}
	sk += "\n";
    } else
	sk = "   None\n";
    
    str = sprintf(
		  "Name: %15s\n" +
		  "Skills:\n",
		  query_name()
		  );

    return str + sk;
}

string
fix_skill_desc(int sktype, mapping sk_desc)
{
    mixed *skarr;
    string desc;

    PROFILE("fix_skill_desc");

    skarr = sk_desc[sktype];

/* query_skill() can be shadowed and if we want it to work fine
 * we must use this_object()-> instead of calling it internally.
 */
    if (pointerp(skarr))
        desc = skarr[0];
    else
        if (!(desc = this_object()->query_skill_name(sktype)))
	    desc = "special";

    return sprintf("<%d> %s: %3d", sktype, desc,
		   this_object()->query_skill(sktype));
/*
    else
	return sprintf("<num %-5d>: %3d", sktype,
		this_object()->query_skill(sktype));
*/
}
