/*  LAST EDIT: Wed Jul 29 19:04:33 1992 by Michael Schmidt (michael)  */
/*     It's time !!!!!!!!!!!
 *
 * Yes, this is the time in Padermud 3.0 !
 * It is the official time system for this Mud, so please use it when you
 * want to make something that works with/on  time.
 * There are some macros that will help you if you do :
 *                 #include "/local/sys/mudtime.h" 
 * in your File.
 *
 * The Time system is nearly the same like here on earth, but a month has
 * 22 days and the year consists of 16 month ! 
 * Seconds->Minutes->Hours->Days is the same as you know from your life.
 * The 'AF' after the year means 'After Fire' and means the years since 
 * poor old Padermud 2.4.5 burned down ! ;-)
 *
 * Any more Questions ? Ask me !
 *            Dimitri, the mighty Avatar !   (Friend of Lord British)
 */



int time,year,month,day,hour,minute,second,weekday;
string *montharray,*quarterarray,*weekdayarray,*monthshortarray;


init_str()
{
  montharray = ({ "alligator","bear","camel","dragon","elephant","fly","ghoul","hobgoblin","insect","jaguar","kangaroo","lizard","monkey","naiad","octopus","phoenix" });
  
  quarterarray = ({ "first quarter","second quarter","third quarter","last quarter" });
  
  weekdayarray = ({ "Spirituality","Sacrifice","Honesty","Honor","Humility","Valor","Justice","Compassion" });

  monthshortarray = ({ "ALLIG","BEAR","CAMEL","DRAGO","ELEPH","FLY","GHOUL","HOBGO","INSEC","JAGUA","KANGA","LIZAR","MONKE","NAIAD","OCTOP","PHOEN" });
  
}



/*  Some Macros one may easily use in his Objects/Rooms/Monsters.... :      */

#define YEAR       time_get_int("year")            /* Year    (integer)        */  
#define MONTH      time_get_int("month")           /* Month   (integer)        */
#define DAY        time_get_int("day")             /* Day     (integer)        */
#define HOUR       time_get_int("hour")            /* Hour    (integer)        */
#define MINUTE     time_get_int("minute")          /* Minute  (integer)        */
#define SECOND     time_get_int("second")          /* Second  (integer)        */
#define WEEKDAY    time_get_int("weekday")         /* Weekday (integer 0-7)    */
#define TIMESTR    time_get_string("time")         /* Time-String              */ 
#define DATESTR    time_get_string("date")         /* Date-String              */
#define MONTHSHORT time_get_string("monthshort")   /* Month in 5 Letters       */
#define WEEKDAYSTR time_get_description("weekday") /* Weekday-String           */
#define TIMEDESC   time_get_description("time")    /* Time-Descr. (for players)*/
#define DATEDESC   time_get_description("date")    /* Date_Descr. (for players)*/



public int
time_get_int(string str)
{

  time=time();
  time=time-693792000;
  time=time*8;
  year=   time/30412800;
  month=  (time-(year*30412800))/1900800;
  day=    (time-(year*30412800)-(month*1900800))/86400;
  hour=   (time-(year*30412800)-(month*1900800)-(day*86400))/3600;
  minute= (time-(year*30412800)-(month*1900800)-(day*86400)-(hour*3600))/60;
  second=  time-(year*30412800)-(month*1900800)-(day*86400)-(hour*3600)-(minute*60);
  weekday=(day+(month*22)+(year*22*16))-((day+(month*22)+(year*22*16))/8)*8;



if (!str) return 9999;

  switch(str)
    {
    case "Year":
    case "year":
      return year+180;
      break;
    case "Month":
    case "month":
      return month+1;
      break;
    case "Day":
    case "day":
      return day+1;
      break;
    case "Hour":
    case "hour":
      return hour;
      break;
    case "Minute":
    case "minute":
      return minute;
      break;
    case "Second":
    case "second":
      return second;
      break;
    case "Weekday":
    case "weekday":
      return weekday;
      break;  
    default:
      return 9999;
    }
}


public nomask string
time_get_description(string str)
{
  string retstr;

  init_str();

  if (!str) return "String angeben !\n";
  
  if (str=="date")
    {
      retstr = "the " + DAY + ". day ( a day of " + weekdayarray[WEEKDAY] + " ) in the month of the " + montharray[MONTH-1] + ", " + YEAR + " years after the big fire";
      return retstr;
    }

  if (str=="time")
    {
      retstr = "the " + quarterarray[(MINUTE/15)] + " of the " + (HOUR+1) + ". hour of this day of " + weekdayarray[WEEKDAY];
      return retstr;
    }

  if (str=="weekday")
    {
      retstr = "day of " + weekdayarray[WEEKDAY];
      return retstr;
    } 
}



public nomask string
time_get_string(string str)
{
  string daystr,monthstr,hourstr,minutestr,secondstr,retstr;

  daystr = ""+DAY;
  monthstr = ""+MONTH;
  hourstr = ""+HOUR;
  minutestr = ""+MINUTE;
  secondstr = ""+SECOND;

  if(DAY<10) daystr="0"+DAY;
  if(MONTH<10) monthstr="0"+MONTH;
  if(HOUR<10) hourstr="0"+HOUR;
  if(MINUTE<10) minutestr="0"+MINUTE;
  if(SECOND<10) secondstr="0"+SECOND;



  if (!str) return "String angeben !\n";

  if (str=="date")
    {
      retstr = daystr + "." + monthstr + ". ( " + WEEKDAYSTR + " ) " + YEAR + " AF";
      return retstr;
    }
  if (str=="time")
    {
      retstr = hourstr + ":" + minutestr + ":" + secondstr;
      return retstr;
    }
  if (str=="monthshort")
    {
      if (!monthshortarray) init_str();
      retstr = monthshortarray[MONTH-1];
      return retstr;
    }
  if (str=="month")
    {
      init_str();
      retstr = montharray[MONTH-1];
      return retstr;
    }

}



public nomask
date_in_weekday(day,month,year,intflag)
{
 int weekdayint;
 if (!year) year = YEAR;

 if (!intp(day) || !intp(month) || !intp(year))
   {
     return -1;
   }
 day = day -1;
 month = month -1;
 year = year -180;
 weekdayint=(day+(month*22)+(year*22*16))-((day+(month*22)+(year*22*16))/8)*8;
 
 if (intflag)    return weekdayint;

 if (!weekday) init_str();

 return weekdayarray[weekdayint];
}

public nomask string
mail_convert(string str)
{
  int mailminute,mailhour,mailday,mailmonth,mailtime,i,mailyear;
  string mailmonthshort;
  if (sscanf(str,"%s  %d %d:%d",mailmonthshort,mailday,mailhour,mailminute) != 4) return str + "  Fehler in Konvertierung !\n";

  if (!monthshortarray) init_str();
  
  for (i=0;i<sizeof(monthshortarray);i++)
    {
      if (mailmonthshort==monthshortarray[i]) mailmonth = i;
    }
  
  if (MONTH<mailmonth) mailyear = YEAR-1;
  else mailyear = YEAR;
  
  mailtime = (((mailminute*60)+(mailhour*3600)+((mailday-1)*68400)+(mailmonth*1900800)+((mailyear-180)*30412800))/8)+693792000;
  /* return mailyear + " " + mailday + "." + mailmonth + "  " + mailhour + ":" + mailminute + "\n"; */ 
  return  "" + mailtime; 
}



