/*
 * /sys/filter_funs.h
 *
 * A set of functions often used by filter
 */

#ifndef FILTER_DEF
#define FILTER_DEF


#define FILTER_FILE "/sys/global/filters"

/*
 * returns all livings in array x.
 */
#define FILTER_LIVE(x)         filter(x, "filter_living", FILTER_FILE)

/*
 * returns all livings in array x without this_player().
 */
#define FILTER_OTHER_LIVE(x)   filter(x, "filter_other_living", FILTER_FILE)

/*
 * returns all interactive players in array x.
 */
#define FILTER_PLAYERS(x)      filter(x, "filter_interactive", FILTER_FILE)

/*
 * returns all non-living objects in array x.
 */
#define FILTER_DEAD(x)         filter(x, "filter_dead", FILTER_FILE)

/*
 * returns all livings in array x that are present in the environment of
 * this_player.
 */
#define FILTER_PRESENT_LIVE(x) filter(x, "filter_present_living", FILTER_FILE)

/*
 * returns all objects in array x that can be seen by living l.
 */
#define FILTER_CAN_SEE(x, l)   filter(x, "filter_can_see", FILTER_FILE, l)


/* no definitions beyond this line. */
#endif FILTER_DEF
