/*
  /sys/filter_funs.c

  A set of functions often used by filter

*/
#pragma save_binary

#include <macros.h>
#include <stdproperties.h>

int
filter_living(object ob)
{
    return living(ob);
}

int
filter_other_living(object ob)
{
    return (living(ob) && this_player() != ob);
}

int
filter_dead(object ob)
{
    return objectp(ob) && (living(ob) == 0);
}

int
filter_shown(mixed ob)
{
    return (ob->query_no_show() != 1) ;
}

varargs int
filter_present_living(object ob, object pl)
{
    return (living(ob) && 
	   ( (pl ? environment(pl) : environment(this_player()) ) == environment(ob)));
}


/* And some map functions
*/

mixed
map_fun(mixed ob, string fun)
{
    return call_other(ob, fun);
}

int
filter_can_see(object ob, object looker)
{
    return CAN_SEE(looker, ob);
}

int
filter_interactive(object ob)
{
    return interactive(ob);
}

