/*
  /sys/map.h

  Inclusion of the local map configuration file. If not some defines

*/

#ifndef MAP_DEF
#include "/config/sys/map_defines.h"
#endif

#ifndef MAP_DEF
#define MAP_DEF

#define MAXY 746          /* Maximum value Y may have */
#define MINY -745         /* Minimum value Y may have */
#define MAXX 495          /* Maximum value X may have */
#define MINX -494         /* Minimum value X may have */
#define X_SECT 5          /* Each map block consists of X_SECT columns */
#define Y_TOT 1491        /* How many are there between MAXY and MINY, 0 included */

#define MAP_SL_MAX 		8            /* 0 - 8 */
#define MAP_WL_MAX 		9999


/*
  Name of the file holding the map information
*/
#define MAP_FILE "/d/Standard/a_map"

/*
  Info on bit patterns in mapfile
*/
#define PLAIN             0x2F
#define RANDOM_ENCOUNTER  0x40
#define DOMAIN_BIT        0x80

/*
  Path to where all maprooms will be created
*/
#define MAP_PATH "/d/Standard/map"

/*
 * MAP_CHARS
 *
 * Printable char for each mapsymbol.
 *
 */
#define MAP_DEFAULT_CHAR 	"-"
#define MAP_CHARS ([           \
		    1 : "~", \
		    2 : "~", \
		    3 : "~", \
		    4 : "~", \
		    5 : "~", \
		    6 : "~", \
		    7 : "/", \
		    8 : "~", \
		    9 : "s", \
		    10 : "%", \
		    11 : "%", \
		    12 : "%", \
		    13 : "%", \
		    14 : "%", \
		    15 : "%", \
		    16 : "%", \
		    17 : "%", \
		    18 : "-", \
		    19 : "+", \
		    20 : "'", \
		    21 : "'", \
		    22 : "'", \
		    23 : "+", \
		    24 : "+", \
		    25 : "t", \
		    26 : "/", \
		    27 : ";", \
		    28 : "/", \
		    29 : "t", \
		    30 : "^", \
		    31 : "V", \
		    ])



/*
 * MAP_ROOMS
 *
 * Mapsymbols and corresponding filenames of terrain rooms 
 *
 */
#define MAP_DEFAULT_ROOM 	"/d/Standard/terrain/plains"
#define MAP_ROOMS ([             			\
		    1 : "/d/Standard/terrain/standard_sea", 		\
		    2 : "/d/Standard/terrain/arctic_sea", 		\
		    3 : "/d/Standard/terrain/cold_sea", 		\
		    4 : "/d/Standard/terrain/temperated_sea", 		\
		    5 : "/d/Standard/terrain/tropical_sea", 		\
		    6 : "/d/Standard/terrain/lake", 			\
		    7 : "/d/Standard/terrain/ice_at_sea",		\
		    8 : "/d/Standard/terrain/river", 			\
		    9 : "/d/Standard/terrain/swamp", 			\
		    10 : "/d/Standard/terrain/jungle", 			\
		    11 : "/d/Standard/terrain/mtn_pineforest", 		\
		    12 : "/d/Standard/terrain/pine_forest", 		\
		    13 : "/d/Standard/terrain/hills_pine_forest", 	\
		    14 : "/d/Standard/terrain/forest", 			\
		    15 : "/d/Standard/terrain/mtn_jungle", 		\
		    16 : "/d/Standard/terrain/hills_forest", 		\
		    17 : "/d/Standard/terrain/hills_jungle", 		\
		    18 : "/d/Standard/terrain/plains", 			\
		    19 : "/d/Standard/terrain/mtn_lightveg", 		\
		    20 : "/d/Standard/terrain/desert", 			\
		    21 : "/d/Standard/terrain/hills_desert", 		\
		    22 : "/d/Standard/terrain/mtn_desert", 		\
		    23 : "/d/Standard/terrain/hills_lightveg", 		\
		    24 : "/d/Standard/terrain/hills_dirt", 		\
		    25 : "/d/Standard/terrain/hills_thundra", 		\
		    26 : "/d/Standard/terrain/mtn_ice", 		\
		    27 : "/d/Standard/terrain/reef", 			\
		    28 : "/d/Standard/terrain/hills_ice", 		\
		    29 : "/d/Standard/terrain/thundra", 		\
		    30 : "/d/Standard/terrain/mountain", 		\
		    31 : "/d/Standard/terrain/vulcano", 		\
		    ])


#endif
